#pragma rtGlobals=1		// Use modern global access method.

// SIS SRS_RGA this macro allows reading and plotting QMS data

#include "Macintosh HD:Applications:Igor Pro 6.3 Folder:User Procedures:SIS_core"

Menu "SRS RGA"
	"Load and Display", SRS_open()
end

function SRS_open()
	Variable refNum
	String fileName="srsdata"
	String messageStr="open SRS file"	
	Open/P=imagePath/R/M=messageStr/Z=2 refNum as fileName
	if (V_flag<-1)	// check if file exists
		printf "File %s not found in the given folder\r",filename
	elseif (V_flag==-1)
		print "Load file operation cancelled by user"
	elseif (V_flag==0)
		printf "Loading %s\r",S_filename
		// set data folder
		String dfStr=ParseFilePath(0, S_fileName, ":", 1, 0)
		variable	i=strsearch(dfStr, ".",strlen(dfStr),3)
		dfStr = "QMS_"+dfStr[0,i-1]
		dfStr = ReplaceString(".", dfStr, "_") 
		dfStr = ReplaceString("-", dfStr, "_") 
		NewDataFolder/S/O root:$(dfStr)
		variable/G n_chan
		String/G units
		SRS_display_and_plot(dfStr,refNum,S_fileName) 
	endif
end

Function SRS_display_and_plot(dfStr,refNum,filenameStr) 
	String dfStr
	Variable refNum
	String filenameStr
	String lineStr=""
	String tmpStr=""
	String matchStr=""
	variable Data_flag=0
	variable k=0
	variable i,i0,i1,i2
	NVAR n_chan=root:$(dfStr):n_chan
	SVAR units=root:$(dfStr):units
	do	
				FReadLine /T=(num2char(13)) refNum, lineStr
				if (k==0)
					printf "Settings of: %s",lineStr
				endif
				// determing N_channels
				matchStr="Active channels in Scan, "
				i0=strsearch(lineStr, matchStr,0)
				if (i0>-1)
					i1=strlen(matchStr)		
					n_chan=str2num(lineStr[1+i1,strlen(lineStr)-1])
					make/o/n=(n_chan)/T chan_names
					make/o/n=(n_chan)/T chan_amu
				endif
				// determining units
				matchStr="Units, "
				i0=strsearch(lineStr, matchStr,0)
				if (i0>-1)
					i1=strlen(matchStr)						
					tmpStr=lineStr[1+i1,strlen(lineStr)-2]
					units=tmpStr
				endif
				// read names and amu
				matchStr="Mass(amu),"
				i0=strsearch(lineStr, matchStr,0)
				if (i0>-1)
					i=0
					do
						FReadLine /T=(num2char(13)) refNum, lineStr
						if (strsearch(lineStr,",",0)>-1)
							// amu
							i1=strsearch(lineStr,",",0)+4 // finds the bieginning of the amu string
							lineStr= lineStr[i1,strlen(lineStr)-2]
							tmpStr=lineStr[0,1]
							chan_amu[i]=lineStr[0,1] //stores it into array
							// name
							i1=strsearch(lineStr,",",0)+6 // finds the bieginning of the Name string
							tmpStr= lineStr[i1,strlen(lineStr)-2]
							i2=strsearch(tmpStr,",",0)
							chan_names[i]="("+chan_amu[i]+") "+tmpStr[0,i2-1]
							i+=1
							k+=1
						else
							if (strlen(lineStr)<5)
								FReadLine /T=(num2char(13)) refNum, lineStr
							endif
							// amu
							i1=strsearch(lineStr,".",0)-2 // finds the bieginning of the amu string
							tmpStr=lineStr[i1,i1+1]
							lineStr=lineStr[i1+15,i1+30]
							chan_amu[i]=tmpStr //stores it into array
							// name
							chan_names[i]="("+chan_amu[i]+") "+lineStr
							i+=1
							k+=1
						endif
					while(i<n_chan)
				endif
				matchStr="Channel#1"
				i0=strsearch(lineStr, matchStr,0)
				if (i0>-1) // means that this is a datafile
					Data_flag=1
				endif
				k+=1
	while (strlen(lineStr)>0)
	close refNum
	if (Data_flag == 1) // that's a data file, then load waves		
		// load waves
		i=0
		String columnInfoStr = "C=1,F=0,T=4,N=SRS_time;"
		String defaultStr = "C=1,F=0,T=4,N=srs_amu"
		do
			columnInfoStr += defaultStr+chan_amu[i]+";"
			i+=1
		while(i<N_chan)
		print columnInfoStr
		Loadwave/A/B=columnInfoStr/D/G/O/Q/P=imagePath filenameStr
		// display
		String legendStr=""
		i=0
		do
			tmpStr="srs_amu"+chan_amu[i]
			legendStr+="\\s(srs_amu"+chan_amu[i]+") "+chan_names[i]+"\r"
			SIS_graphToFront(dfStr,tmpStr,"SRS_time")
			doUpdate
			i+=1
		while(i<N_chan)
		String unitsStr="\\F'Arial'\\Z18Partial Pressure ("+units+" \\u\\F'Arial'\\Z18)"
		Label left unitsStr;DelayUpdate
		Label bottom "\\F'Arial'\\Z18Time (s)"
		ModifyGraph log(left)=1
		ModifyGraph fSize=12
		ModifyGraph width=340.157,height={Aspect,0.8}
		Legend/K/N=text0
		legendStr=legendStr[0,strlen(legendStr)-2]
		Legend/C/N=legendtext/J legendStr
		ModifyGraph nticks(bottom)=10
	else
		print "you did not load a datafile, rather the settings of the RGA"
	endif
	
End





