#pragma rtGlobals=3		// Use modern global access method and strict wave access.

Menu "WKF"
"StorageMatrices"
"CalculateWKF"
"ResetWKFwaves"
End

///////////////////////////////////////////////////////////////////////------------------------------------------------------///////////////////////////////////////////////////////////////////////
Proc StorageMatrices()
	WKF_Matrices()
End

Proc CalculateWKF()
	WKF_CalculateDeltaWKF()
End

Proc ResetWKFwaves()
	WKF_ResetWaves()
End


///////////////////////////////////////////////////////////////////////------------------------------------------------------///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////------------------------------------------------------///////////////////////////////////////////////////////////////////////

Function WKF_Matrices()
	String dfStr=SIS_getDataFolderName()
	SetDataFolder root:SIS
	
			make/O/N=(2) WKF_Ir, WKF_BG, WKF_FG
			make/O/N=(1) WKF_Ir_err, WKF_BG_err, WKF_FG_err
			DoWindow/K TemporaryWKF
			string name = "TemporaryWKF"
			edit/N=$name WKF_Ir,WKF_Ir_err, WKF_FG, WKF_FG_err, WKF_BG, WKF_BG_err
			make/O/N=(1) DeltaWKF_FG, DeltaWKF_BG
			make/O/N=(1) DeltaWKF_FG_err, DeltaWKF_BG_err
			DoWindow/K WKFresults
			edit/N=WKFresults DeltaWKF_FG, DeltaWKF_FG_err, DeltaWKF_BG , DeltaWKF_BG_err	
			
	SetDataFolder root:$(dfStr)

End

///////////////////////////////////////////////////////////////////////------------------------------------------------------///////////////////////////////////////////////////////////////////////

Function WKF_CalculateDeltaWKF()
	String dfStr=SIS_getDataFolderName()
	SetDataFolder root:SIS
	wave WKF_Ir, WKF_BG, WKF_FG, WKF_Ir_err, WKF_BG_err, WKF_FG_err
	wave  DeltaWKF_FG, DeltaWKF_FG_err, DeltaWKF_BG , DeltaWKF_BG_err
	
	DeltaWKF_FG[0] = WKF_Ir[0] - WKF_FG[0]
	DeltaWKF_FG_err[0] = WKF_Ir_err[0] + WKF_FG_err[0]
	DeltaWKF_BG[0] = WKF_Ir[0] - WKF_BG[0]
	DeltaWKF_BG_err[0] = WKF_Ir_err[0] + WKF_BG_err[0]

	SetDataFolder root:$(dfStr)

End

///////////////////////////////////////////////////////////////////////------------------------------------------------------///////////////////////////////////////////////////////////////////////

Function WKF_ResetWaves()
	String dfStr=SIS_getDataFolderName()
	SetDataFolder root:SIS
	wave WKF_Ir, WKF_BG, WKF_FG, WKF_Ir_err, WKF_BG_err, WKF_FG_err
	wave  DeltaWKF_FG, DeltaWKF_FG_err, DeltaWKF_BG , DeltaWKF_BG_err
	WKF_Ir = Nan
	WKF_BG = Nan
	WKF_FG = Nan
	WKF_Ir_err = Nan
	WKF_BG_err = Nan
	WKF_FG_err = Nan
	DeltaWKF_FG = Nan
 	DeltaWKF_FG_err = Nan
 	DeltaWKF_BG = Nan
 	DeltaWKF_BG_err = Nan
 
	SetDataFolder root:$(dfStr)

End